
exit:
	mov	esi, .pwoff
	call	puts
	call	getc
	cmp	al, ESC
	je	.ret
	mov	bl, al

	call	protected2real
use16
	cmp	bl, 'x'
	je	.off
	jmp	0xf000:0xfff0	; reset
.off:
; CONNECT APM BIOS
	mov	ax, 0x5301
	mov	bx, 0x0
	int	0x15

; UPGRADE VERSION
	mov	ax, 0x530e
	mov	bx, 0x0
	mov	cx, 0x0102
	int	0x15
	
; ENABLE POWER MANAGEMENT
	mov	ax, 0x5308
	mov	bx, 0x1
	mov	cx, 0x1
	int	0x15

; SET POWER STATE: OFF
	mov	ax, 0x5307
	mov	bx, 0x1
	mov	cx, 0x3
	int	0x15

	call	real2protected
use32
.ret:
	mov	al, 0xa
	call	putc
	ret

.pwoff	db 'x - power off, r - restart, <Esc> - cancel: ', 0