
; asm kernel efer
; (c) 2008 kflavour
include 'kerndefs.inc'

include 'boot.asm'	; kernel loader

use16
org KERNBASE
start:
	dw 0xc085	; signature 0xc085

	mov	si, about
	call	puts16
		
	lgdt	fword [gdtr]
	lidt	fword [idtr]

	call	real2protected
use32
; SET CALL GETES
	mov	word [REAL2PROT], real2protected
	mov	dword [PROT2REAL], protected2real
	mov	dword [PUTC], putc
	mov	dword [PUTS], puts
	mov	dword [GETC], getc
	mov	dword [GETS], gets
	mov	dword [OUTCHAR], outchar

	

; DISPLAY ABOUT STR
	mov	esi, flatmod
	call	puts

	mov	edx, start
	mov	edi, stcode + skip_si
	call	edxtostr
	mov	edx, endc
	mov	edi, endcode + skip_si
	call	edxtostr
	mov	edx, esp
	mov	edi, stk + skip_si
	call	edxtostr
	mov	esi, sysinf
	call	puts

	mov	esi, est
	call	puts

wait_ctrl:
	call	inchar
	cmp	al, CTRL
	jne	wait_ctrl

	jmp	shell

halt:	hlt
	jmp	halt

est	db 'press <Ctrl> to start shell ', 0
	
include 'kernel.inc'
include 'stdio.inc'
include 'display.inc'
include 'keyboard.inc'
include 'stdio16.inc'
include 'shell.inc'

endc: