
; shell for efer
; (c) 2008 kflavour

shell:
	mov	[attrib], 00011111b
	call	cls

	mov	[curpos], 0
	call	setcurpos

	call	full_cursor

main_loop:
	mov	edi, CMDLN
	mov	ecx, 254
	call	gets

	mov	ah, byte [CMDLN]
	test	ah, ah
	jz	main_loop
	xor	ecx, ecx

	mov	esi, cmds
	cld
next_cmdchar:
	lodsb
	test	al, al
	jz	undef_cmd
	cmp	ah, al
	je	start_cmd
	inc	ecx
	jmp	next_cmdchar
	
start_cmd:
	call	dword [pcmds + ecx * 4]
	jmp	main_loop

cmds	db 'idxemcrw', 0

align 4
pcmds:
	dd info
	dd dump
	dd exit
	dd edit
	dd move
	dd exec
	dd driveio
	dd driveio

	
	
	
	
	
undef_cmd:
	mov	esi, undcmd
	call	puts
	jmp	main_loop
	
undcmd	db 'undefined command, try ', 0x27, 'i', 0x27, 0xa, 0

cls:
	mov	ecx, HEIGHT
    @@:	push	ecx
	call	scrollscr
	pop	ecx
	loop	@b
	ret

full_cursor:
	mov	dx, 0x3d4	; CRT ctrl

	mov	ah, 0
	mov	al, 0xa
	out	dx, ax

	mov	ah, 00011111b
	mov	al, 0xb		; cursor end
	out	dx, ax
	ret

include 'cmds\info.inc'
include 'cmds\dump.inc'
include 'cmds\exit.inc'
include 'cmds\edit.inc'
include 'cmds\move.inc'
include 'cmds\exec.inc'
include 'cmds\driveio.inc'
