
; prototype: l <drive> <start_block> <nblocks> <buff_seg> <buff_offs>

driveio:
	mov	esi, CMDLN + 2
	cmp	byte [esi - 1], ' '
	jne	.usage

.term_sp:
	lodsb
	test	al, al
	jz	@f
	cmp	al, ' '
	jne	.term_sp
	mov	byte [esi - 1], 0
	jmp	.term_sp
@@:
	mov	esi, CMDLN + 2
	push	esi
	call	strtoedx
	mov	[drive], dl
	pop	esi

	call	.seekparam
	push	esi
	call	strtoedx
	mov	dword [startblk], edx
	pop	esi

	call	.seekparam
	push	esi
	call	strtoedx
	mov	[nblocks], dx
	pop	esi
	test	dx, dx
	jz	.0_blocks

	
	call	.seekparam
	push	esi
	call	strtoedx
	mov	word [transbuff + 2], dx

	pop	esi
	call	.seekparam
	push	esi
	call	strtoedx
	mov	word [transbuff], dx
	pop	esi
	cmp	dx, 0x2000
	jb	.low_buffaddr


	call	protected2real
use16
	mov	dl, [drive]
	mov	si, addrpkt
	mov	ah, 0x42
	mov	al, 0
	cmp	byte [CMDLN], 'w'
	jne	@f
	inc	ah
    @@:	int	0x13
	
	salc
	mov	[.err], al
	call	real2protected
use32
	cmp	[.err], 0
	je	@f
	mov	esi, .err_rd
	call	puts
	ret
@@:
	mov	al, 0xa
	call	putc
	ret	
	
.0_blocks:
	mov	esi, .0blk
	call	puts
	ret

.0blk	db 'err: set 0 blocks', 0xa, 0



.low_buffaddr:
	mov	esi, .low_ba
	call	puts
	ret

.low_ba	db 'err: buff offset can', 0x27, 't low 2000', 0xa, 0

		
.usage:
	mov	al, [CMDLN]
	mov	[.use + 7], al
	mov	esi, .use
	call	puts
	ret

.use	db 'usage: ? <drive> <start_block> <nblocks> <buff_seg> <buff_offs>', 0xa, 0

.err		db ?

.err_rd	db 'err read through int 13/42', 0xa, 0

.ex		db ?
	
.seekparam:
	lodsb
	test	al, al
	jnz	.seekparam
	ret

drive		db ?
	
addrpkt:
pktsize		db 0x10
reserv		db 0
nblocks		dw ?
transbuff	dd ?
startblk	dq ?
