
; GLOBAL KERNEL DEFENITIONS

KERNBASE	= 0x900		; phys addr where boot loader load kernel
KERNSTACKTOP	= 0xffff
KBDBUFF		= 0x800
KBD_BUFFPOS	= 0x8ff

; CALL GATES
GATESBASE	= 0x700

REAL2PROT	= GATESBASE
PROT2REAL	= GATESBASE + 4
PUTC		= GATESBASE + 8
PUTS		= GATESBASE + 12
GETC		= GATESBASE + 16
GETS		= GATESBASE + 20
OUTCHAR		= GATESBASE + 24


; SEGMENT SELECTORS
flatCS	= 00001000b
flatDS	= 00010000b
realCS	= 00011000b

VIDEO	= 0xb8000

; KBD KEYS
ESC	= 0x1b
BKSP	= 0x8
TAB	= 0x9
ENTR	= 0xa
CTRL	= 0x1d
ALT	= 0x12

; COMMAND LINE
CMDLN	= 0x600