
; keyboard control
; (c) 2008 kflavour

include 'kerndefs.inc'


;char al inchar(void)
inchar:
	mov	byte [KBD_BUFFPOS], 0
	hlt
	cmp	byte [KBD_BUFFPOS], 0
	je	inchar
	mov	al, [KBDBUFF]
	cmp	al, 0x39
	ja	inchar
	ret




;::::::::GET:STRING::::::::::::::
;void gets(char *(str)edi, int (count)ecx)
gets:
	enter	4, 0
	test	ecx, ecx
	jz	eol
	mov	[ebp - 4], edi
  next_char:
	push	edi
	push	ecx

	call	getc

	pop	ecx
	pop	edi
	cmp	al, ENTR
	je	eol
	cmp	al, BKSP
	jne	@f
	cmp	edi, [ebp - 4]	; check out of begin
	jbe	next_char
	dec	edi
	mov	byte [edi], 0
	jmp	next_char	
   @@:	stosb
	loop	next_char
  eol:
	xor	al, al		; zero terminate
	stosb
	leave
	ret

;::::::::GET:CHAR::::::::::::::::
;(char) al getc(void)

getc:
	mov	byte [KBD_BUFFPOS], 0
  pending_input:
	hlt
	cmp	byte [KBD_BUFFPOS], 0
	jz	pending_input
	movzx	eax, byte [KBDBUFF]
	mov	al, [ascii_tab + eax]
	test	al, al
	jz	getc
	push	eax
	call	putc
	pop	eax
	ret
	
	
align 16
ascii_tab:
db 0
db ESC, '1234567890-=', BKSP, TAB, 'qwertyuiop[]'
db ENTR, CTRL, 'asdfghjkl;', 0x27, '`', 0, '\zxcvbnm,./', 0
db 0, ALT, ' '

times 256 - ($ - ascii_tab) db 0x0